<template>
  <v-autocomplete
    v-model="selectedValue"
    :items="data"
    item-text="name"
    item-value="id"
    :loading="loading"
    :label="label"
    :hide-no-data="!search"
    :readonly="readonly"
    :filled="filled"
    :hint="hint"
    :persistent-hint="persistentHint"
    :search-input.sync="search"
    clearable
    @keyup="load(search, $event)"
    @change="$emit('change')"
    :rules="rules"
  />
</template>

<script lang="ts">
import { Component, Vue, Prop, Watch } from 'vue-property-decorator'
import _ from 'lodash'
import api from '../../plugins/api'

@Component({ components: {} })
export default class ClientSelect extends Vue {
  @Prop({ required: true }) value!: string
  @Prop({ default: 'Klienti*' }) label!: string
  @Prop({ default: false }) readonly!: boolean
  @Prop({ default: false }) filled!: boolean
  @Prop({ default: '' }) next!: string
  @Prop({ default: '' }) clientName!: string
  @Prop({ default: '' }) hint!: string
  @Prop({ default: false }) persistentHint!: boolean
  rules: any = [(value: any) => !!value || 'Fusha nuk mund të lihet bosh']
  data: Array<any> = []
  search?: string = ''
  loading?: boolean = false

  public get selectedValue() {
    return this.value
  }
  public set selectedValue(newValue: string) {
    this.$emit('input', newValue)
    this.$emit('change', newValue)

    const newClient = this.data.find(i => i.id === newValue)
    if (newClient) {
      this.$emit('selected', newClient.name)
    }
  }

  fetch() {
    this.loading = true
    api()
      .get(
        '/api/crm/clients?resource=ClientSelectResource&page-size=10&qs=' +
          this.search
      )
      .then(response => {
        this.data = response.data.data

        if (this.data.length === 1) {
          this.selectedValue = this.data[0].id
          const nextEl = document.getElementById(this.next)
          if (nextEl) nextEl.focus()
        }
      })
      .finally(() => {
        this.loading = false
      })
  }

  @Watch('clientName')
  onClientNameChanged() {
    this.search = this.clientName
    this.fetch()
  }

  load(search, event) {
    _.debounce((search, event) => {
      if (
        [
          'ArrowUp',
          'ArrowDown',
          'ArrowLeft',
          'ArrowRight',
          'Meta',
          'ControlLeft',
          'ControlRight',
          'ShiftRight',
          'ShiftLeft',
        ].find(item => item === event.key)
      ) {
        return false
      }
      if (event.key === 'Enter' && this.data.length === 1) {
        this.selectedValue = this.data[0].id
        const nextEl = document.getElementById(this.next)
        if (nextEl) nextEl.focus()
      }
      this.fetch()
    }, 500)(search, event)
  }
  mounted() {
    this.fetch()
  }
}
</script>
